--[[
Survival.LUA
Created by Megabyte
]]

Triggers = {}

ROUND=0
TOTALAREA=0
monsters=0
timer=150
liveguys=0
over=false

iconwait = [[
2
A00FF00
 000000
     AAAAAA     
   AAAAAAAAAA   
  AAAAAAAAAAAA  
 AAAAAAAAAAAAAA 
 AAAAAAAAAAAAAA 
AAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAA 
 AAAAAAAAAAAAAA 
  AAAAAAAAAAAA  
   AAAAAAAAAA   
     AAAAAA     
]]

iconfight = [[
2
AFF0000
 000000
     AAAAAA     
   AAAAAAAAAA   
  AAAAAAAAAAAA  
 AAAAAAAAAAAAAA 
 AAAAAAAAAAAAAA 
AAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAA
 AAAAAAAAAAAAAA 
 AAAAAAAAAAAAAA 
  AAAAAAAAAAAA  
   AAAAAAAAAA   
     AAAAAA     
]]

CollectionsUsed = { 8, 9, 10, 11, 14, 16 } --load enemies

function Triggers.init()


	
	for m in MonsterTypes() do
		for n in MonsterClasses() do
			m.friends[n]=true
			m.enemies[n]=false
		end
		m.enemies["player"]=true
		m.friends["player"]=false
		m.item=nil
	end
	
	for p in Players() do
		p._revived=false
		p._ready=false
		p._anno=Annotations.new(p.polygon, "", 0, 0)
	end
	
	for p in Polygons() do
		p._checked=false
		p._spawn=true
	end
	for p in Polygons() do
		if p.type=="hill" then
			check(p)
		end
	end
	
	for p in Polygons() do
		if not p._checked then
			p._spawn=false
		end
		if p._spawn then
			TOTALAREA=TOTALAREA+p.area
		end
	end
		
	Triggers.idle()
end

function check(p)
	p._checked=true
	if (p.floor.collection==27 or p.floor.collection==28 or p.floor.collection==29 or p.floor.collection==30) then
		p._spawn=false
	end
	
	if p.ceiling.z-p.floor.z<.75 then
		p._spawn=false
	end
	
	if p.type == "base" then
		p._spawn=false
	end

	for q in p:adjacent_polygons() do
		check1=true
		
		for l in p:lines() do
			if l.ccw_polygon==q or l.cw_polygon==q then
				if l.solid then
					check1=false
				end
			end
		end
		
		if (q.z-p.z<=(1/3)) and check1 and not q._checked then
			check(q)
		end
	end
end
	
function Triggers.idle()
	
	for a in Annotations() do
		a.polygon=Polygons[0]
		a.text=""
		a.x=0
		a.y=0
	end
	
	liveguys=0
	for p in Players() do
		
		if not p.disconnected then
			p.compass.lua=true
			p._closest=-1
			for q in Players() do
				if q.dead and not q.disconnected then
					dist=((p.x-q.x)^2 + (p.y-q.y)^2)^(.5)
					if p._closest==-1 then
						p._closest=q.index
					else
						dist1=((p.x-Players[p._closest].x)^2 + (p.y-Players[p._closest].y)^2)^(.5)
						if dist<=dist1 then
							p._closest=q.index
						end
					end
				end
			end
			if not p.dead then
				liveguys=liveguys+1
				if p.action_flags.microphone_button then
					p._ready=true
				end
				if not p._closest==-1 then
					dist1=((p.x-Players[p._closest].x)^2 + (p.y-Players[p._closest].y)^2)^(.5)
					angle=-math.acos((p.x-Players[p._closest].x)/dist1) - p.yaw
					
					if angle <=0 then
						angle = angle+math.pi/2
					end
					if angle<=math.pi/2 then
						p.compass.ne=true
					elseif angle<=math.pi then
						p.compass.nw=true
					elseif angle<=(math.pi*3/2) then
						p.compass.sw=true
					elseif angle<=(2*math.pi) then
						p.compass.se=true
					end
					p.compass.lua=true
					p.compass.beacon=true
					p.compass.x=Players[p._closest].x
					p.compass.y=Players[p._closest].y
				end
			end
			
			if p.dead and not p._revived then
				p.action_flags.action_trigger = false
				if p.external_velocity.z==0 then --JIGGLE THAT BODY LOL
					p:position(p.x, p.y, p.z+.1, p.polygon)
				end	
				for r in Players() do
					if not r.dead then
						p:view_player(r)
					end
				end
				p._anno.polygon=p.polygon
				p._anno.text=p.name
				p._anno.x=p.x
				p._anno.y=p.y
			end
			for q in Players() do
				if not (q==p) then
					dist=((p.x-q.x)^2 + (p.y-q.y)^2)^(.5)
					if p.dead and not q.dead and dist<=1.5 and q.action_flags.action_trigger and not p._revived then
						p._revived=true
						q.points=q.points+5
						for r in Players() do
							r:print(p.name.." was revived by "..q.name)
						end
					end
				end
			end
			if p._revived then
				p._anno.polygon=p.polygon
				p._anno.text=" "
				p._anno.x=0
				p._anno.y=0
				p.action_flags.action_trigger = true
				if not p.dead then
					p._revived = not p._revived
				end
				p:view_player(p)
			end
		end
	end
	for p in Players() do
		pcall(display,p)
	end
	if liveguys==0 then
		over=true
	end
	monsters=0
	for m in Monsters() do
		if m.valid and not m.player then
			monsters=monsters+1
			if m.life>0 then
				m._x=m.x
				m._y=m.y
				m._z=m.z
				m._p=m.polygon
			end
		end
		if m.life<0 and (not m.player) then
			m:position(100,100,100,0)
		end
	end
	if monsters==0 then
		if timer == 0 then
			ROUND=ROUND+1
			spawn()
			--clearmonsters()
			timer=150*ROUND
			if timer>600 then
				timer=600
			end
			for p in Players() do
				p._ready=false
			end
		elseif timer==150*ROUND or timer==600 then
			timer=timer-1
			for p in Players() do
				p:play_sound("siren", 1)
			end
		else
			timer=timer-1
			ready=0
			live=0
			for p in Players() do
				if p.life>0 then				
					live=live+1
					if p._ready then
						ready=ready+1
					end
				end
			end
			if ready>=(live/2) then
				timer=0
			end
		end
	else
		for p in Players() do
			p._ready=false
		end
	end
end

function display(p)
	if monsters==0 then
		p.overlays[0].icon=iconwait
		readies=0
		for q in Players() do
			if q.life>0 then				
				if q._ready then
					readies=readies+1
				end
			end
		end
		displaytext="Round/Monsters/Players: "..ROUND.."/"..monsters.."/"..liveguys.."   Readies/Counter: "..readies.."/"..round((timer/30),0)
	else
		p.overlays[0].icon=iconfight
		displaytext="Round/Monsters/Players: "..ROUND.."/"..monsters.."/"..liveguys.."   Counter: In Progress"
	end
	p.overlays[0].text=displaytext
	len=displaytext:len()
	p.overlays[1].color="green"
	
	if p._closest>=0 then
		len=displaytext:len()
		displaytext2=""
		for i=1,len do
			displaytext2=displaytext2.." "
		end
		displaytext2=displaytext2.."	"..Players[p._closest].name
		p.overlays[1].text=displaytext2
	else
		p.overlays[1].text=""
	end
end

function clearmonsters()
	for m in Monsters() do
		m:position(m._x,m._y,m._z,m._p)
	end
end

function spawn()
	for p in Players() do
		p:play_sound("alarm", 1)
	end
	
	for p in Polygons() do
		if p._spawn then
			if --[[(p.area/TOTALAREA)>=(1/(20*ROUND)) and]] p._spawn then
				monsters=round((20*ROUND*p.area/TOTALAREA), 0)
				AVGX=0
				AVGY=0
				numpoints=0
				for e in p:endpoints() do
					AVGX=AVGX+e.x
					AVGY=AVGY+e.y
					numpoints=numpoints+1
				end
				AVGX=AVGX/numpoints
				AVGY=AVGY/numpoints
				for i=1, monsters do
					rand=1+Game.random(40)
					if rand<=10 then
						mtype="major fighter"
					elseif rand<=15 then
						mtype="sewage yeti"
					elseif rand<=22 then
						mtype="major projectile fighter"
					elseif rand<=27 then
						mtype="major compiler"
					elseif rand<=34 then
						mtype="major trooper"
					elseif rand<=39 then
						mtype="minor enforcer"
					elseif rand<=40 then
						mtype="minor defender"
					end
					newmonster=Monsters.new(AVGX, AVGY, .5, p, mtype)
					newmonster.visible=true
					newmonster.active=true
				end
			end
		end
	end
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function Triggers.monster_killed(monster, aggressor_player, projectile)
	pcall(score, aggressor_player, 6)
end

function Triggers.player_killed(player, aggressor_player, action, projectile)
	pcall(score, aggressor_player, 0)
end

function score(player, modifier)
	player.points=player.points+modifier-5
end

function Triggers.player_killed(player, aggressor_player, action, projectile)
	for p in Players() do
		p:print(player.name.." was killed")
		p:play_sound("you are it", 1)
	end
end

function Triggers.postidle()
	if over then
		Game.over=over
	end
	for p in Players() do
		if p.dead and not p.disconnected and not p._revived then
			Effects.new(p.x, p.y, p.z+.5, p.polygon, "major fusion contrail")
		end
	end
	for m in Monsters() do
		if m.life<0 and (not m.player) then
			m:position(m._x,m._y,m._z,m._p)
		end
	end
end
